"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useAsyncToggle;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var callAll = function callAll(errCallback) {
  for (var _len = arguments.length, fns = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    fns[_key - 1] = arguments[_key];
  }

  return /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var _len2,
        args,
        _key2,
        _iterator,
        _step,
        fn,
        res,
        _args = arguments;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            for (_len2 = _args.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = _args[_key2];
            }

            _iterator = _createForOfIteratorHelper(fns);
            _context.prev = 2;

            _iterator.s();

          case 4:
            if ((_step = _iterator.n()).done) {
              _context.next = 20;
              break;
            }

            fn = _step.value;
            _context.prev = 6;
            _context.next = 9;
            return fn === null || fn === void 0 ? void 0 : fn.apply(void 0, args);

          case 9:
            res = _context.sent;
            console.log("from fn of fns", fn.name, res);
            _context.next = 18;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context["catch"](6);
            console.log(_context.t0.message);
            errCallback();
            return _context.abrupt("break", 20);

          case 18:
            _context.next = 4;
            break;

          case 20:
            _context.next = 25;
            break;

          case 22:
            _context.prev = 22;
            _context.t1 = _context["catch"](2);

            _iterator.e(_context.t1);

          case 25:
            _context.prev = 25;

            _iterator.f();

            return _context.finish(25);

          case 28:
            console.log("callAll ends");

          case 29:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 22, 25, 28], [6, 13]]);
  }));
};

function toggleReducer(state, _ref2) {
  var type = _ref2.type;

  switch (type) {
    case "toggle":
      {
        return {
          on: !state.on,
          pending: false
        };
      }

    case "start loading":
      {
        return {
          on: state.on,
          pending: true
        };
      }

    case "stop loading":
      {
        return {
          on: state.on,
          pending: false
        };
      }

    default:
      {
        throw new Error("Unsupported type: ".concat(type));
      }
  }
}

function useAsyncToggle() {
  var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref3$initialOn = _ref3.initialOn,
      initialOn = _ref3$initialOn === void 0 ? false : _ref3$initialOn,
      _ref3$reducer = _ref3.reducer,
      reducer = _ref3$reducer === void 0 ? toggleReducer : _ref3$reducer;

  var _React$useRef = _react["default"].useRef({
    on: initialOn,
    pending: false
  }),
      initialState = _React$useRef.current;

  var _React$useReducer = _react["default"].useReducer(reducer, initialState),
      _React$useReducer2 = (0, _slicedToArray2["default"])(_React$useReducer, 2),
      state = _React$useReducer2[0],
      dispatch = _React$useReducer2[1];

  var on = state.on,
      pending = state.pending;

  var toggle = function toggle() {
    dispatch({
      type: "toggle"
    });
  };

  var startLoading = function startLoading() {
    return dispatch({
      type: "start loading",
      initialState: initialState
    });
  };

  var stopLoading = function stopLoading() {
    return dispatch({
      type: "stop loading",
      initialState: initialState
    });
  };

  var forwardError = function forwardError(e) {
    throw e;
  };

  function getTogglerProps() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        onClick = _ref4.onClick,
        props = (0, _objectWithoutProperties2["default"])(_ref4, ["onClick"]);

    return _objectSpread({
      "aria-pressed": on,
      on: on,
      pending: pending,
      onClick: callAll(stopLoading, startLoading, onClick, toggle)
    }, props);
  }

  return {
    on: on,
    pending: pending,
    toggle: toggle,
    startLoading: startLoading,
    stopLoading: stopLoading,
    getTogglerProps: getTogglerProps,
    forwardError: forwardError // to be called in case error for custom onClick is being handled externally

  };
}